# -*- coding: utf-8 -*-

'''
Created on 18-Sep-2017

@author: abhinav
'''
import ujson as json
import re

country_iso2_to_data = {"AF": ["Afghanistan", "AFG", "004"], "AL": ["Albania", "ALB", "008"], "DZ": ["Algeria", "DZA", "012"], "AS": ["American Samoa", "ASM", "016"], "AD": ["Andorra", "AND", "020"], "AO": ["Angola", "AGO", "024"], "AI": ["Anguilla", "AIA", "660"], "AQ": ["Antarctica", "ATA", "010"], "AG": ["Antigua and Barbuda", "ATG", "028"], "AR": ["Argentina", "ARG", "032"], "AM": ["Armenia", "ARM", "051"], "AW": ["Aruba", "ABW", "533"], "AU": ["Australia", "AUS", "036"], "AT": ["Austria", "AUT", "040"], "AZ": ["Azerbaijan", "AZE", "031"], "BS": ["Bahamas (the)", "BHS", "044"], "BH": ["Bahrain", "BHR", "048"], "BD": ["Bangladesh", "BGD", "050"], "BB": ["Barbados", "BRB", "052"], "BY": ["Belarus", "BLR", "112"], "BE": ["Belgium", "BEL", "056"], "BZ": ["Belize", "BLZ", "084"], "BJ": ["Benin", "BEN", "204"], "BM": ["Bermuda", "BMU", "060"], "BT": ["Bhutan", "BTN", "064"], "BO": ["Bolivia (Plurinational State of)", "BOL", "068"], "BQ": ["Bonaire, Sint Eustatius and Saba", "BES", "535"], "BA": ["Bosnia and Herzegovina", "BIH", "070"], "BW": ["Botswana", "BWA", "072"], "BV": ["Bouvet Island", "BVT", "074"], "BR": ["Brazil", "BRA", "076"], "IO": ["British Indian Ocean Territory (the)", "IOT", "086"], "BN": ["Brunei Darussalam", "BRN", "096"], "BG": ["Bulgaria", "BGR", "100"], "BF": ["Burkina Faso", "BFA", "854"], "BI": ["Burundi", "BDI", "108"], "CV": ["Cabo Verde", "CPV", "132"], "KH": ["Cambodia", "KHM", "116"], "CM": ["Cameroon", "CMR", "120"], "CA": ["Canada", "CAN", "124"], "KY": ["Cayman Islands (the)", "CYM", "136"], "CF": ["Central African Republic (the)", "CAF", "140"], "TD": ["Chad", "TCD", "148"], "CL": ["Chile", "CHL", "152"], "CN": ["China", "CHN", "156"], "CX": ["Christmas Island", "CXR", "162"], "CC": ["Cocos (Keeling) Islands (the)", "CCK", "166"], "CO": ["Colombia", "COL", "170"], "KM": ["Comoros (the)", "COM", "174"], "CD": ["Congo (the Democratic Republic of the)", "COD", "180"], "CG": ["Congo (the)", "COG", "178"], "CK": ["Cook Islands (the)", "COK", "184"], "CR": ["Costa Rica", "CRI", "188"], "HR": ["Croatia", "HRV", "191"], "CU": ["Cuba", "CUB", "192"], "CW": ["Cura\\u00e7ao", "CUW", "531"], "CY": ["Cyprus", "CYP", "196"], "CZ": ["Czechia", "CZE", "203"], "CI": ["C\\u00f4te d\'Ivoire", "CIV", "384"], "DK": ["Denmark", "DNK", "208"], "DJ": ["Djibouti", "DJI", "262"], "DM": ["Dominica", "DMA", "212"], "DO": ["Dominican Republic (the)", "DOM", "214"], "EC": ["Ecuador", "ECU", "218"], "EG": ["Egypt", "EGY", "818"], "SV": ["El Salvador", "SLV", "222"], "GQ": ["Equatorial Guinea", "GNQ", "226"], "ER": ["Eritrea", "ERI", "232"], "EE": ["Estonia", "EST", "233"], "SZ": ["Eswatini", "SWZ", "748"], "ET": ["Ethiopia", "ETH", "231"], "FK": ["Falkland Islands (the) [Malvinas]", "FLK", "238"], "FO": ["Faroe Islands (the)", "FRO", "234"], "FJ": ["Fiji", "FJI", "242"], "FI": ["Finland", "FIN", "246"], "FR": ["France", "FRA", "250"], "GF": ["French Guiana", "GUF", "254"], "PF": ["French Polynesia", "PYF", "258"], "TF": ["French Southern Territories (the)", "ATF", "260"], "GA": ["Gabon", "GAB", "266"], "GM": ["Gambia (the)", "GMB", "270"], "GE": ["Georgia", "GEO", "268"], "DE": ["Germany", "DEU", "276"], "GH": ["Ghana", "GHA", "288"], "GI": ["Gibraltar", "GIB", "292"], "GR": ["Greece", "GRC", "300"], "GL": ["Greenland", "GRL", "304"], "GD": ["Grenada", "GRD", "308"], "GP": ["Guadeloupe", "GLP", "312"], "GU": ["Guam", "GUM", "316"], "GT": ["Guatemala", "GTM", "320"], "GG": ["Guernsey", "GGY", "831"], "GN": ["Guinea", "GIN", "324"], "GW": ["Guinea-Bissau", "GNB", "624"], "GY": ["Guyana", "GUY", "328"], "HT": ["Haiti", "HTI", "332"], "HM": ["Heard Island and McDonald Islands", "HMD", "334"], "VA": ["Holy See (the)", "VAT", "336"], "HN": ["Honduras", "HND", "340"], "HK": ["Hong Kong", "HKG", "344"], "HU": ["Hungary", "HUN", "348"], "IS": ["Iceland", "ISL", "352"], "IN": ["India", "IND", "356"], "ID": ["Indonesia", "IDN", "360"], "IR": ["Iran (Islamic Republic of)", "IRN", "364"], "IQ": ["Iraq", "IRQ", "368"], "IE": ["Ireland", "IRL", "372"], "IM": ["Isle of Man", "IMN", "833"], "IL": ["Israel", "ISR", "376"], "IT": ["Italy", "ITA", "380"], "JM": ["Jamaica", "JAM", "388"], "JP": ["Japan", "JPN", "392"], "JE": ["Jersey", "JEY", "832"], "JO": ["Jordan", "JOR", "400"], "KZ": ["Kazakhstan", "KAZ", "398"], "KE": ["Kenya", "KEN", "404"], "KI": ["Kiribati", "KIR", "296"], "KP": ["Korea (the Democratic People\'s Republic of)", "PRK", "408"], "KR": ["Korea (the Republic of)", "KOR", "410"], "KW": ["Kuwait", "KWT", "414"], "KG": ["Kyrgyzstan", "KGZ", "417"], "LA": ["Lao People\'s Democratic Republic (the)", "LAO", "418"], "LV": ["Latvia", "LVA", "428"], "LB": ["Lebanon", "LBN", "422"], "LS": ["Lesotho", "LSO", "426"], "LR": ["Liberia", "LBR", "430"], "LY": ["Libya", "LBY", "434"], "LI": ["Liechtenstein", "LIE", "438"], "LT": ["Lithuania", "LTU", "440"], "LU": ["Luxembourg", "LUX", "442"], "MO": ["Macao", "MAC", "446"], "MG": ["Madagascar", "MDG", "450"], "MW": ["Malawi", "MWI", "454"], "MY": ["Malaysia", "MYS", "458"], "MV": ["Maldives", "MDV", "462"], "ML": ["Mali", "MLI", "466"], "MT": ["Malta", "MLT", "470"], "MH": ["Marshall Islands (the)", "MHL", "584"], "MQ": ["Martinique", "MTQ", "474"], "MR": ["Mauritania", "MRT", "478"], "MU": ["Mauritius", "MUS", "480"], "YT": ["Mayotte", "MYT", "175"], "MX": ["Mexico", "MEX", "484"], "FM": ["Micronesia (Federated States of)", "FSM", "583"], "MD": ["Moldova (the Republic of)", "MDA", "498"], "MC": ["Monaco", "MCO", "492"], "MN": ["Mongolia", "MNG", "496"], "ME": ["Montenegro", "MNE", "499"], "MS": ["Montserrat", "MSR", "500"], "MA": ["Morocco", "MAR", "504"], "MZ": ["Mozambique", "MOZ", "508"], "MM": ["Myanmar", "MMR", "104"], "NA": ["Namibia", "NAM", "516"], "NR": ["Nauru", "NRU", "520"], "NP": ["Nepal", "NPL", "524"], "NL": ["Netherlands (the)", "NLD", "528"], "NC": ["New Caledonia", "NCL", "540"], "NZ": ["New Zealand", "NZL", "554"], "NI": ["Nicaragua", "NIC", "558"], "NE": ["Niger (the)", "NER", "562"], "NG": ["Nigeria", "NGA", "566"], "NU": ["Niue", "NIU", "570"], "NF": ["Norfolk Island", "NFK", "574"], "MP": ["Northern Mariana Islands (the)", "MNP", "580"], "NO": ["Norway", "NOR", "578"], "OM": ["Oman", "OMN", "512"], "PK": ["Pakistan", "PAK", "586"], "PW": ["Palau", "PLW", "585"], "PS": ["Palestine, State of", "PSE", "275"], "PA": ["Panama", "PAN", "591"], "PG": ["Papua New Guinea", "PNG", "598"], "PY": ["Paraguay", "PRY", "600"], "PE": ["Peru", "PER", "604"], "PH": ["Philippines (the)", "PHL", "608"], "PN": ["Pitcairn", "PCN", "612"], "PL": ["Poland", "POL", "616"], "PT": ["Portugal", "PRT", "620"], "PR": ["Puerto Rico", "PRI", "630"], "QA": ["Qatar", "QAT", "634"], "MK": ["Republic of North Macedonia", "MKD", "807"], "RO": ["Romania", "ROU", "642"], "RU": ["Russian Federation (the)", "RUS", "643"], "RW": ["Rwanda", "RWA", "646"], "RE": ["R\\u00e9union", "REU", "638"], "BL": ["Saint Barth\\u00e9lemy", "BLM", "652"], "SH": ["Saint Helena, Ascension and Tristan da Cunha", "SHN", "654"], "KN": ["Saint Kitts and Nevis", "KNA", "659"], "LC": ["Saint Lucia", "LCA", "662"], "MF": ["Saint Martin (French part)", "MAF", "663"], "PM": ["Saint Pierre and Miquelon", "SPM", "666"], "VC": ["Saint Vincent and the Grenadines", "VCT", "670"], "WS": ["Samoa", "WSM", "882"], "SM": ["San Marino", "SMR", "674"], "ST": ["Sao Tome and Principe", "STP", "678"], "SA": ["Saudi Arabia", "SAU", "682"], "SN": ["Senegal", "SEN", "686"], "RS": ["Serbia", "SRB", "688"], "SC": ["Seychelles", "SYC", "690"], "SL": ["Sierra Leone", "SLE", "694"], "SG": ["Singapore", "SGP", "702"], "SX": ["Sint Maarten (Dutch part)", "SXM", "534"], "SK": ["Slovakia", "SVK", "703"], "SI": ["Slovenia", "SVN", "705"], "SB": ["Solomon Islands", "SLB", "090"], "SO": ["Somalia", "SOM", "706"], "ZA": ["South Africa", "ZAF", "710"], "GS": ["South Georgia and the South Sandwich Islands", "SGS", "239"], "SS": ["South Sudan", "SSD", "728"], "ES": ["Spain", "ESP", "724"], "LK": ["Sri Lanka", "LKA", "144"], "SD": ["Sudan (the)", "SDN", "729"], "SR": ["Suriname", "SUR", "740"], "SJ": ["Svalbard and Jan Mayen", "SJM", "744"], "SE": ["Sweden", "SWE", "752"], "CH": ["Switzerland", "CHE", "756"], "SY": ["Syrian Arab Republic", "SYR", "760"], "TW": ["Taiwan (Province of China)", "TWN", "158"], "TJ": ["Tajikistan", "TJK", "762"], "TZ": ["Tanzania, United Republic of", "TZA", "834"], "TH": ["Thailand", "THA", "764"], "TL": ["Timor-Leste", "TLS", "626"], "TG": ["Togo", "TGO", "768"], "TK": ["Tokelau", "TKL", "772"], "TO": ["Tonga", "TON", "776"], "TT": ["Trinidad and Tobago", "TTO", "780"], "TN": ["Tunisia", "TUN", "788"], "TR": ["Turkey", "TUR", "792"], "TM": ["Turkmenistan", "TKM", "795"], "TC": ["Turks and Caicos Islands (the)", "TCA", "796"], "TV": ["Tuvalu", "TUV", "798"], "UG": ["Uganda", "UGA", "800"], "UA": ["Ukraine", "UKR", "804"], "AE": ["United Arab Emirates (the)", "ARE", "784"], "GB": ["United Kingdom of Great Britain and Northern Ireland (the)", "GBR", "826"], "UM": ["United States Minor Outlying Islands (the)", "UMI", "581"], "US": ["United States of America (the)", "USA", "840"], "UY": ["Uruguay", "URY", "858"], "UZ": ["Uzbekistan", "UZB", "860"], "VU": ["Vanuatu", "VUT", "548"], "VE": ["Venezuela (Bolivarian Republic of)", "VEN", "862"], "VN": ["Viet Nam", "VNM", "704"], "VG": ["Virgin Islands (British)", "VGB", "092"], "VI": ["Virgin Islands (U.S.)", "VIR", "850"], "WF": ["Wallis and Futuna", "WLF", "876"], "EH": ["Western Sahara", "ESH", "732"], "YE": ["Yemen", "YEM", "887"], "ZM": ["Zambia", "ZMB", "894"], "ZW": ["Zimbabwe", "ZWE", "716"], "AX": ["Aland Islands", "ALA", "248"]}

phone_codes_list = {'93': ['AF', 'Afghanistan'], '358': ['FI', 'Finland'], '355': ['AL', 'Albania'], '213': ['DZ', 'Algeria'], '1684': ['AS', 'AmericanSamoa'], '376': ['AD', 'Andorra'], '244': ['AO', 'Angola'], '1264': ['AI', 'Anguilla'], '672': ['NF', 'Norfolk Island'], '1268': ['AG', 'Antigua and Barbuda'], '54': ['AR', 'Argentina'], '374': ['AM', 'Armenia'], '297': ['AW', 'Aruba'], '61': ['CC', 'Cocos (Keeling) Islands'], '43': ['AT', 'Austria'], '994': ['AZ', 'Azerbaijan'], '1242': ['BS', 'Bahamas'], '973': ['BH', 'Bahrain'], '880': ['BD', 'Bangladesh'], '1246': ['BB', 'Barbados'], '375': ['BY', 'Belarus'], '32': ['BE', 'Belgium'], '501': ['BZ', 'Belize'], '229': ['BJ', 'Benin'], '1441': ['BM', 'Bermuda'], '975': ['BT', 'Bhutan'], '591': ['BO', 'Bolivia, Plurinational State of Bolivia'], '387': ['BA', 'Bosnia and Herzegovina'], '267': ['BW', 'Botswana'], '47': ['SJ', 'Svalbard and Jan Mayen'], '55': ['BR', 'Brazil'], '246': ['IO', 'British Indian Ocean Territory'], '673': ['BN', 'Brunei Darussalam'], '359': ['BG', 'Bulgaria'], '226': ['BF', 'Burkina Faso'], '257': ['BI', 'Burundi'], '855': ['KH', 'Cambodia'], '237': ['CM', 'Cameroon'], '1': ['US', 'United States'], '238': ['CV', 'Cape Verde'], '1345': ['KY', 'Cayman Islands'], '236': ['CF', 'Central African Republic'], '235': ['TD', 'Chad'], '56': ['CL', 'Chile'], '86': ['CN', 'China'], '57': ['CO', 'Colombia'], '269': ['KM', 'Comoros'], '242': ['CG', 'Congo'], '243': ['CD', 'Congo, The Democratic Republic of the Congo'], '682': ['CK', 'Cook Islands'], '506': ['CR', 'Costa Rica'], '225': ['CI', "Cote d'Ivoire"], '385': ['HR', 'Croatia'], '53': ['CU', 'Cuba'], '357': ['CY', 'Cyprus'], '420': ['CZ', 'Czech Republic'], '45': ['DK', 'Denmark'], '253': ['DJ', 'Djibouti'], '1767': ['DM', 'Dominica'], '1849': ['DO', 'Dominican Republic'], '593': ['EC', 'Ecuador'], '20': ['EG', 'Egypt'], '503': ['SV', 'El Salvador'], '240': ['GQ', 'Equatorial Guinea'], '291': ['ER', 'Eritrea'], '372': ['EE', 'Estonia'], '251': ['ET', 'Ethiopia'], '500': ['GS', 'South Georgia and the South Sandwich Islands'], '298': ['FO', 'Faroe Islands'], '679': ['FJ', 'Fiji'], '33': ['FR', 'France'], '594': ['GF', 'French Guiana'], '689': ['PF', 'French Polynesia'], '241': ['GA', 'Gabon'], '220': ['GM', 'Gambia'], '995': ['GE', 'Georgia'], '49': ['DE', 'Germany'], '233': ['GH', 'Ghana'], '350': ['GI', 'Gibraltar'], '30': ['GR', 'Greece'], '299': ['GL', 'Greenland'], '1473': ['GD', 'Grenada'], '590': ['MF', 'Saint Martin'], '1671': ['GU', 'Guam'], '502': ['GT', 'Guatemala'], '44': ['GB', 'United Kingdom'], '224': ['GN', 'Guinea'], '245': ['GW', 'Guinea-Bissau'], '592': ['GY', 'Guyana'], '509': ['HT', 'Haiti'], '379': ['VA', 'Holy See (Vatican City State)'], '504': ['HN', 'Honduras'], '852': ['HK', 'Hong Kong'], '36': ['HU', 'Hungary'], '354': ['IS', 'Iceland'], '91': ['IN', 'India'], '62': ['ID', 'Indonesia'], '98': ['IR', 'Iran, Islamic Republic of Persian Gulf'], '964': ['IQ', 'Iraq'], '353': ['IE', 'Ireland'], '972': ['IL', 'Israel'], '39': ['IT', 'Italy'], '1876': ['JM', 'Jamaica'], '81': ['JP', 'Japan'], '962': ['JO', 'Jordan'], '77': ['KZ', 'Kazakhstan'], '254': ['KE', 'Kenya'], '686': ['KI', 'Kiribati'], '850': ['KP', "Korea, Democratic People's Republic of Korea"], '82': ['KR', 'Korea, Republic of South Korea'], '383': ['XK', 'Kosovo'], '965': ['KW', 'Kuwait'], '996': ['KG', 'Kyrgyzstan'], '856': ['LA', 'Laos'], '371': ['LV', 'Latvia'], '961': ['LB', 'Lebanon'], '266': ['LS', 'Lesotho'], '231': ['LR', 'Liberia'], '218': ['LY', 'Libyan Arab Jamahiriya'], '423': ['LI', 'Liechtenstein'], '370': ['LT', 'Lithuania'], '352': ['LU', 'Luxembourg'], '853': ['MO', 'Macao'], '389': ['MK', 'Macedonia'], '261': ['MG', 'Madagascar'], '265': ['MW', 'Malawi'], '60': ['MY', 'Malaysia'], '960': ['MV', 'Maldives'], '223': ['ML', 'Mali'], '356': ['MT', 'Malta'], '692': ['MH', 'Marshall Islands'], '596': ['MQ', 'Martinique'], '222': ['MR', 'Mauritania'], '230': ['MU', 'Mauritius'], '262': ['RE', 'Reunion'], '52': ['MX', 'Mexico'], '691': ['FM', 'Micronesia, Federated States of Micronesia'], '373': ['MD', 'Moldova'], '377': ['MC', 'Monaco'], '976': ['MN', 'Mongolia'], '382': ['ME', 'Montenegro'], '1664': ['MS', 'Montserrat'], '212': ['MA', 'Morocco'], '258': ['MZ', 'Mozambique'], '95': ['MM', 'Myanmar'], '264': ['NA', 'Namibia'], '674': ['NR', 'Nauru'], '977': ['NP', 'Nepal'], '31': ['NL', 'Netherlands'], '599': ['AN', 'Netherlands Antilles'], '687': ['NC', 'New Caledonia'], '64': ['PN', 'Pitcairn'], '505': ['NI', 'Nicaragua'], '227': ['NE', 'Niger'], '234': ['NG', 'Nigeria'], '683': ['NU', 'Niue'], '1670': ['MP', 'Northern Mariana Islands'], '968': ['OM', 'Oman'], '92': ['PK', 'Pakistan'], '680': ['PW', 'Palau'], '970': ['PS', 'Palestinian Territory, Occupied'], '507': ['PA', 'Panama'], '675': ['PG', 'Papua New Guinea'], '595': ['PY', 'Paraguay'], '51': ['PE', 'Peru'], '63': ['PH', 'Philippines'], '48': ['PL', 'Poland'], '351': ['PT', 'Portugal'], '1939': ['PR', 'Puerto Rico'], '974': ['QA', 'Qatar'], '40': ['RO', 'Romania'], '7': ['RU', 'Russia'], '250': ['RW', 'Rwanda'], '290': ['SH', 'Saint Helena, Ascension and Tristan Da Cunha'], '1869': ['KN', 'Saint Kitts and Nevis'], '1758': ['LC', 'Saint Lucia'], '508': ['PM', 'Saint Pierre and Miquelon'], '1784': ['VC', 'Saint Vincent and the Grenadines'], '685': ['WS', 'Samoa'], '378': ['SM', 'San Marino'], '239': ['ST', 'Sao Tome and Principe'], '966': ['SA', 'Saudi Arabia'], '221': ['SN', 'Senegal'], '381': ['RS', 'Serbia'], '248': ['SC', 'Seychelles'], '232': ['SL', 'Sierra Leone'], '65': ['SG', 'Singapore'], '421': ['SK', 'Slovakia'], '386': ['SI', 'Slovenia'], '677': ['SB', 'Solomon Islands'], '252': ['SO', 'Somalia'], '27': ['ZA', 'South Africa'], '211': ['SS', 'South Sudan'], '34': ['ES', 'Spain'], '94': ['LK', 'Sri Lanka'], '249': ['SD', 'Sudan'], '597': ['SR', 'Suriname'], '268': ['SZ', 'Eswatini'], '46': ['SE', 'Sweden'], '41': ['CH', 'Switzerland'], '963': ['SY', 'Syrian Arab Republic'], '886': ['TW', 'Taiwan'], '992': ['TJ', 'Tajikistan'], '255': ['TZ', 'Tanzania, United Republic of Tanzania'], '66': ['TH', 'Thailand'], '670': ['TL', 'Timor-Leste'], '228': ['TG', 'Togo'], '690': ['TK', 'Tokelau'], '676': ['TO', 'Tonga'], '1868': ['TT', 'Trinidad and Tobago'], '216': ['TN', 'Tunisia'], '90': ['TR', 'Turkey'], '993': ['TM', 'Turkmenistan'], '1649': ['TC', 'Turks and Caicos Islands'], '688': ['TV', 'Tuvalu'], '256': ['UG', 'Uganda'], '380': ['UA', 'Ukraine'], '971': ['AE', 'United Arab Emirates'], '598': ['UY', 'Uruguay'], '998': ['UZ', 'Uzbekistan'], '678': ['VU', 'Vanuatu'], '58': ['VE', 'Venezuela, Bolivarian Republic of Venezuela'], '84': ['VN', 'Vietnam'], '1284': ['VG', 'Virgin Islands, British'], '1340': ['VI', 'Virgin Islands, U.S.'], '681': ['WF', 'Wallis and Futuna'], '967': ['YE', 'Yemen'], '260': ['ZM', 'Zambia'], '263': ['ZW', 'Zimbabwe']}

#The base is always INR
currencies_list = json.loads('''{"POINTS":["Points", 1000, "Points"], "APP_CURRENCY":["☈", 1, "Route"], "DZD":["DZD",1.7418266083,"Algeria"],"NAD":["$",0.206540442,"Namibia"],"QAR":["﷼",0.057486937,"Qatar"],"EGP":["£",0.2762029722,"Egypt"],"BGN":["лв",0.025561126,"Bulgaria"],"PAB":["B\/.",0.0156078701,"Panama"],"BOB":["$b",0.1079022178,"Bolivia"],"DKK":["kr",0.0972755208,"Greenland"],"BWP":["P",0.1589740941,"Botswana"],"LBP":["£",23.5572832874,"Lebanon"],"TZS":["TZS",35.0219116781,"Tanzania"],"VND":["₫",354.7201331778,"Vietnam"],"AOA":["AOA",2.5903795077,"Angola"],"KHR":["៛",63.6448611114,"Cambodia"],"MYR":["RM",0.0653733601,"Malaysia"],"KYD":["$",0.0127984538,"Cayman Islands"],"LYD":["LYD",0.0208561594,"Libya"],"UAH":["₴",0.4087790681,"Ukraine"],"JOD":["JOD",0.0110545375,"Jordan"],"AWG":["ƒ",0.0279380874,"Aruba"],"SAR":["﷼",0.0585366924,"Saudi Arabia"],"BND":["$",0.0210131005,"Brunei Darussalam"],"HKD":["$",0.1220126992,"Hong Kong"],"CHF":["CHF",0.014985205,"Switzerland"],"GIP":["£",0.0115093715,"Gibraltar"],"XPF":["XPF",1.5599345121,"Wallis and Futuna Islands"],"XPD":["XPD",0.0000166557,"unknown"],"BYN":["BYN",0.0302201159,"unknown"],"MRO":["MRO",5.5745219532,"Mauritania"],"HRK":["kn",0.0977793134,"Croatia"],"DJF":["DJF",2.7889958548,"Djibouti"],"SZL":["SZL",0.206540442,"Swaziland"],"THB":["฿",0.5161629323,"Thailand"],"XAF":["XAF",8.574834688,"Gabon"],"XAG":["XAG",0.0008905384,"unknown"],"ETB":["ETB",0.3660480675,"Ethiopia"],"UYU":["$U",0.4521827779,"Uruguay"],"NIO":["C$",0.4739444781,"Nicaragua"],"LAK":["₭",129.9863617987,"Laos"],"GHS":["GHS",0.0691233934,"Ghana"],"SYP":["£",8.0579494502,"Syria"],"MAD":["MAD",0.1459417973,"Western Sahara"],"MZN":["MT",0.9527368856,"Mozambique"],"GEL":["₾",0.038584879,"Georgia"],"ZAR":["R",0.206540442,"South Africa"],"NPR":["₨",1.5991791627,"Nepal"],"BTN":["BTN",1.0,"Bhutan"],"NGN":["₦",5.5951710655,"Nigeria"],"ZWD":["Z$",5.6484881831,"Zimbabwe"],"CRC":["₡",8.9995650472,"Costa Rica"],"AED":["AED",0.0573392242,"United Arab Emirates"],"GBP":["£",0.0115093715,"United Kingdom"],"MWK":["MWK",11.3299126953,"Malawi"],"LKR":["₨",2.3886877104,"Sri Lanka"],"PKR":["₨",1.6456120997,"Pakistan"],"HUF":["Ft",4.0463491532,"Hungary"],"RON":["lei",0.0601233734,"Romania"],"LSL":["LSL",0.206540442,"Lesotho"],"MNT":["₮",38.6065663707,"Mongolia"],"AMD":["AMD",7.4656150474,"Armenia"],"UGX":["UGX",56.1380715446,"Uganda"],"XDR":["XDR",0.0109690202,"unknown"],"JMD":["J$",2.041346097,"Jamaica"],"TTD":["TT$",0.1052529835,"Trinidad and Tobago"],"SHP":["£",0.0115093715,"Saint Helena"],"AFN":["؋",1.0712991438,"Afghanistan"],"MMK":["MMK",21.153698178,"Myanmar"],"KPW":["₩",2.0138406974,"North Korea"],"MKD":["ден",0.803585207,"Macedonia"],"TRY":["TRY",0.0541211951,"Turkey"],"BDT":["BDT",1.2695926417,"Bangladesh"],"YER":["﷼",3.9040934264,"Yemen"],"CVE":["CVE",1.4456220206,"Cape Verde"],"GGP":["£",0.0115093715,"Guernsey"],"HTG":["HTG",0.9838090775,"Haiti"],"SLL":["SLL",118.3705339499,"Sierra Leone"],"MGA":["MGA",46.6138835737,"unknown"],"PHP":["₱",0.7981357915,"Philippines"],"LRD":["$",1.8261785339,"Liberia"],"XCD":["$",0.0421412517,"Saint Vincent and the Grenadines"],"NOK":["kr",0.1221414034,"Svalbard and Jan Mayen Islands"],"MOP":["MOP",0.1256730802,"Macau"],"INR":["₹",1.0,"India"],"MXN":["$",0.2763189421,"Mexico"],"CZK":["Kč",0.3410555811,"Czech Republic"],"TJS":["TJS",0.1373959293,"Tajikistan"],"PYG":["Gs",88.2981783868,"Paraguay"],"COP":["$",45.1701020556,"Colombia"],"TMT":["TMT",0.0540032311,"Turkmenistan"],"MUR":["₨",0.5200758101,"Mauritius"],"IDR":["Rp",206.8423349876,"Indonesia"],"HNL":["L",0.3648203992,"Honduras"],"FJD":["$",0.0316053837,"Fiji"],"ISK":["kr",1.6636981469,"Iceland"],"PEN":["S\/.",0.050738759,"Peru"],"BZD":["BZ$",0.0312188329,"Belize"],"ILS":["₪",0.055070041,"Israel"],"DOP":["RD$",0.7419021822,"Dominican Republic"],"AZN":["₼",0.026353426,"Azerbaijan"],"MDL":["MDL",0.2753143931,"Moldova"],"XPT":["XPT",0.0000161165,"unknown"],"BSD":["$",0.0156078701,"Bahamas"],"SPL":["SPL",0.0026013117,"unknown"],"SEK":["kr",0.1242717691,"Sweden"],"MVR":["MVR",0.2409084339,"Maldives"],"AUD":["$",0.0194893171,"Tuvalu"],"SRD":["$",0.1159062994,"Suriname"],"CUP":["₱",0.4136085572,"Cuba"],"BBD":["$",0.0312157402,"Barbados"],"KMF":["KMF",6.431126016,"Comoros"],"KRW":["₩",17.5894016614,"South Korea"],"GMD":["GMD",0.7321671038,"Gambia"],"VEF":["Bs",0.1558210567,"Venezuela"],"GTQ":["Q",0.113817096,"unknown"],"ANG":["ƒ",0.027877733,"Netherlands Antilles"],"CUC":["CUC",0.0156078701,"unknown"],"TVD":["$",0.0194893171,"unknown"],"CLP":["$",9.7572400037,"Chile"],"ZMW":["ZMW",0.149663523,"Zambia"],"EUR":["€",0.0130722512,"Vatican"],"ALL":["Lek",1.7466014,"Albania"],"RWF":["RWF",13.184677842,"Rwanda"],"KZT":["лв",5.3100482933,"Kazakhstan"],"RUB":["₽",0.898803355,"Russia"],"CDF":["CDF",24.3411993143,"Democratic Republic of the Congo"],"OMR":["﷼",0.0060095026,"Oman"],"BRL":["R$",0.0485277136,"Brazil"],"SBD":["$",0.1218646203,"Solomon Islands"],"PLN":["zł",0.0560079679,"Poland"], "KSH":["KSH",1.6097831136,"Kenya"], "KES":["KES",1.6097831136,"Kenya"],"SVC":["$",0.1365688632,"El Salvador"],"USD":["$",0.0156078701,"United states of America (US)"],"TWD":["NT$",0.4698464945,"Taiwan"],"TOP":["TOP",0.0349165838,"Tonga"],"JEP":["£",0.0115093715,"unknown"],"VUV":["VUV",1.6640666041,"Vanuatu"],"GNF":["GNF",140.2779050467,"Guinea"],"WST":["WST",0.0387953675,"Samoa"],"IQD":["IQD",18.2039473822,"Iraq"],"ERN":["ERN",0.2394698093,"Eritrea"],"BAM":["KM",0.0255671011,"Bosnia and Herzegovina"],"SCR":["₨",0.2110049153,"Seychelles"],"CAD":["$",0.0190398726,"Canada"],"GYD":["$",3.2364264611,"Guyana"],"KWD":["KWD",0.0047053881,"Kuwait"],"BIF":["BIF",27.2700447842,"Burundi"],"PGK":["PGK",0.0500400081,"Papua New Guinea"],"SOS":["S",9.0358673517,"Somalia"],"SGD":["$",0.0210131005,"Singapore"],"UZS":["лв",126.2219671692,"Uzbekistan"],"STD":["STD",320.7501969268,"Sao Tome and Principe"],"IRR":["﷼",522.2172502444,"Iran"],"CNY":["¥",0.1024545103,"China"],"XOF":["XOF",8.574834688,"Togo"],"TND":["TND",0.0381098075,"Tunisia"],"NZD":["$",0.0213611912,"Tokelau"],"FKP":["£",0.0115093715,"Falkland Islands"],"KGS":["лв",1.0708444234,"Kyrgyzstan"],"ARS":["$",0.2649713354,"Argentina"],"BMD":["$",0.0156078701,"Bermuda"],"IMP":["£",0.0115093715,"unknown"],"RSD":["Дин.",1.5575841079,"Serbia"],"BHD":["BHD",0.0058878335,"Bahrain"],"JPY":["¥",1.7384309684,"Japan"],"SDG":["SDG",0.104120669,"Sudan"],"XAU":["XAU",0.0000118718,"unknown"]}''')

country_to_currency_code = {"NL": "EUR", "US": "USD", "IN": "INR", "CA": "CAD", "IE": "EUR", "KE": "KSH"}

alias_currencies_list = {"RS" : currencies_list["INR"]}


country_iso2_to_iso3 = {iso2 : data[1] for iso2, data in country_iso2_to_data.items()}

country_iso3_to_iso2 = {y: x for x, y in country_iso2_to_iso3.items()}

iso2_to_phone_code = {y[0]: x for x, y in phone_codes_list.items()}

iso3_to_phone_code = {country_iso2_to_iso3.get(iso2, '_|_') : ph_code for iso2, ph_code in iso2_to_phone_code.items()}



currencies_list.update(alias_currencies_list)

#points  =
def make_nearrest_currency(val, f):
	val = int(val)
	if val == 0:
		return f
	if(val%f == 0):
		return val
	return f * (val / f + 1)


'''
	return APP_CURRENCY_VALUE, CURRENCY_CODE, VALUE_IN_CURRENCY_CODE
'''
num_regex = re.compile('([0-9\.]+)')
def parse_currency_string(currency_str, default_currency_code="EUR", country_code=None):
	val = num_regex.findall(currency_str)
	if(not val):
		return 0, default_currency_code, 0

	val = val[0]
	currency_code = currency_str.replace(val, "").strip().upper()
	currency_data = currencies_list.get(currency_code)
	if(not currency_data):
		if(country_code):
			currency_code = country_to_currency_code.get(country_code)
		if(not currency_code):
			currency_code = default_currency_code
		currency_data = currencies_list.get(currency_code)

	return (int(val) / currency_data[1]) * 1000, currency_code, int(val)


def convert_currency(val, from_currency='APP_CURRENCY', to_currency='POINTS'):
	from_currency_data = currencies_list.get(from_currency.upper())
	to_currency_data = currencies_list.get(to_currency.upper())

	return (val / from_currency_data[1]) * to_currency_data[1]



# simply parse number , units
def parse_string_to_units(full_str, default_unit="EUR"):
	val = num_regex.findall(full_str)
	if(not val):
		return 0, default_unit

	units_value = val[0]
	units_code = full_str.replace(units_value, "").strip() or default_unit

	return float(units_value or "0"), units_code

		
def test():
	print(parse_currency_string("1000 EUR"))
